#!/usr/local/bin/perl
#==============================================================================
# LinkScan
#==============================================================================
# (c) Copyright 1997-2013 Electronic Software Publishing Corporation (Elsop)
# All Rights Reserved.
# LinkScan(TM) and Elsop(TM) are
# Trademarks of Electronic Software Publishing Corporation
# WWW: http://www.elsop.com/  Email: linkscan@elsop.com
#
# See the file docs/license.txt for terms and conditions of use
#==============================================================================
$qsm='12.4';
print "\n";
print "Welcome to the LinkScan $qsm Configurator. This utility will help you\n";
print "configure LinkScan on your computer. It will complete the installation on\n";
print "many servers, but manual adjustment may be required on others. LinkScan\n";
print "prefers to be installed in its own directory (e.g. linkscan) under your web\n";
print "server root, but this is not mandatory.\n\n";
print "Your Server and Login names are:\n\n";

$ANew=getpwuid($<);
$met=`uname -n`;
$met=~tr/\0\r\n//d;
print "Server Name: $met\n";
print "Login  Name: $ANew\n\n";
$qsyR='';
until($qsyR=~m/^[yn]/i){
  print "Do you have a LinkScan License Key for this Server and Login? [y/n]: ";
  $qsyR=<STDIN>;
  $qsyR=~s/[\n\r]//g;
  if($qsyR=~m/^n/i){
    print "\nIf you do not already have a LinkScan License Key, free evaluation\n";
    print "licenses are available from:\n\n";
    print "http://www.elsop.com/linkscan/dleval.cgi\n\n";
    print "If you need a modified License Key, please e-mail <linkscan\@elsop.com>\n";
    print "Be sure to include the following information in your message:\n\n";
    print "* Your Name (or Company Name)\n";
    print "* Your Existing 10-Digit License Number\n";
    print "* Your Server Name: $met\n";
    print "* Your Login Name:  $ANew\n\n";
    exit;
  }
}

$QdB='linkscan.sys';
$pIe='default/linkscan.cfg';
$Mcbr=0;
open(TST,">>$QdB") || $Mcbr++;
close(TST);
open(TST,">>$pIe") || $Mcbr++;
if($Mcbr){
  print "\n** Error: There appears to be a permissions problem\n";
  print "          Can't initialize linkscan.sys and default/linkscan.cfg\n\n";
  exit;
}

print "\n\nGood. Let's start by entering your License Key details.\n";
print "Enter the following License Key details *exactly* as they appear on\n";
print "the e-mail notification you received. If the backspace key echoes strange\n";
print "characters when entering this data, try using <control-H> instead.\n\n";
$IoFU='';
until($IoFU=~m/^\d{10,10}$/){
  print "Enter License Number [10 digits]: ";
  $IoFU=<STDIN>;
  $IoFU=~s/[\n\r\s]//g;
}
$UHv='';
until($UHv){
  print "Enter Licensee: ";
  $UHv=<STDIN>;
  $UHv=~s/[\n\r]//g;
}
$aLkd='';
until($aLkd=~m/\d+:\d+:\d+:\d+:\d+/){
  print "Enter License Key: ";
  $aLkd=<STDIN>;
  $aLkd=~s/[\n\r\s]//g;
}
print "\n\nEnter the name of your organization or web site as you wish it to\n";
print "appear on the LinkScan reports.\n";
$VJTv='';
until($VJTv){
  print "Enter Organization Name: ";
  $VJTv=<STDIN>;
  $VJTv=~s/[\n\r]//g;
}

$KcsT=`pwd`;
$KcsT=~s/[\r\n\s]//g;
until($KcsT){
  print "\n\nThe LinkScan Configurator could not figure out the full pathname\n";
  print "to the current directory. Please enter it manually.\n";
  print "Enter Full Pathname to Current Directory: ";
  $KcsT=<STDIN>;
  $KcsT=~s/[\n\r\s]//g;
  stat($KcsT);
  if(! -d _){print "Invalid entry: $KcsT\n";$KcsT='';}
}
unless($KcsT=~m#/$#){$KcsT .='/';}
$SNi=$KcsT.'weblint/weblint';

print "\n\nNow LinkScan needs to know where to find some other programs.\n";
$nWP='/usr/local/bin/perl';
print "Enter the *absolute pathname* to the Perl 5 executable.\n";
print "Enter 'return' for the default: $nWP\n";
$wcFC='';
until($wcFC){
  print "Enter Perl 5 Pathname: ";
  $wcFC=<STDIN>;
  $wcFC=~s/[\n\r\s]//g;
  $wcFC=~s#\\#/#g;
  unless($wcFC){$wcFC=$nWP;}
  stat($wcFC);
  if(! -e _ || -d _){print "Invalid entry: $wcFC\n";$wcFC='';}
}

$qsyR='';
until($qsyR=~m/^[yn]/i){
  print "\nIs LinkScan installed in a web-visible directory under www root? [y/n]: ";
  $qsyR=<STDIN>;
  $qsyR=~s/[\n\r]//g;
}
if($qsyR=~m/^n/i){
  print "\nWhen prompted for a URL to the LinkScan directory, please supply the URL\n";
  print "to some other web-visible directory. You can create one later, if you prefer.\n";
  print "Then, copy the LinkScan docs/ directory (and the files therein) into that\n";
  print "directory so the LinkScan documentation can be viewed via a browser.\n";
}else{
  print "\nNow LinkScan needs a URL to *this* directory so that the documentation\n";
  print "and reports are available via a web browser.\n";
}
print "Enter the full URL. For example: http://www.example.com/linkscan/\n";
$TkSl='';
until($TkSl=~m#^https?://#){
  print "Enter LinkScan URL: ";
  $TkSl=<STDIN>;
  $TkSl=~s/[\n\r\s]//g;
}
unless($TkSl=~m#/$#) {$TkSl .='/';}
$fkmu=$TkSl;
$EaiD=$KcsT.'docs/';
$eYC=$TkSl.'docs/';
$jnw=$KcsT.'reports/';
$FPgd=$TkSl.'reports/';

print "\n\nDoes your server require that CGI scripts be installed in a special\n";
print "directory (e.g. cgi-bin)?\n";
$uHtT='';
$EMn=0;
$dxRF='';
until($uHtT=~m/^[yn]/i){
  print "[y/n]: ";
  $uHtT=<STDIN>;
  $uHtT=~s/[\n\r\s]//g;
  if($uHtT=~m/^y/i){$EMn=1;}
}
if($EMn){
  print "\n\nEnter the *absolute pathname* of your special cgi-bin directory.\n";
  print "For example: /usr/www/cgi-bin/\n";
  until($dxRF){
    print "Enter cgi-bin Pathname: ";
    $dxRF=<STDIN>;
    $dxRF=~s/[\n\r\s]//g;
    $dxRF=~s#\\#/#g;
    stat($dxRF);
    if(! -d _){print "Invalid entry: $dxRF\n";$dxRF='';}
  }
  unless($dxRF=~m#/$#){$dxRF .='/';}
  print "\n\nEnter the full URL to your special cgi-bin directory.\n";
  print "For example: http://www.example.com/cgi-bin/\n";
  $fkmu='';
  until($fkmu){
    print "Enter cgi-bin URL: ";
    $fkmu=<STDIN>;
    $fkmu=~s/[\n\r\s]//g;
    $fkmu=~s#\\#/#g;
    unless($fkmu=~m#^https*://#i){$fkmu='';}
  }
  unless($fkmu=~m#/$#){$fkmu .='/';}
}

print "\n\nDo you access the Internet via a Proxy Server?\n";
$uHtT='';
$uxRV='';
until($uHtT=~m/^[yn]/i){
  print "[y/n]: ";
  $uHtT=<STDIN>;
  $uHtT=~s/[\r\n\s]//g;
  if($uHtT=~m/^y/i){$uxRV=1;}
}
if($uxRV){
  $uxRV='';
  until($uxRV=~m/[a-zA-Z0-9\.\-]+/o){
    print "\n\nEnter the Proxy Server host name: ";
    $uxRV=<STDIN>;
    $uxRV=~s/[\r\n\s]//g;
  }
  $Tlw='';
  until($Tlw=~m/\d+/i){
    print "\n\nEnter the Proxy Port Number for HTTP: ";
    $Tlw=<STDIN>;
    $Tlw=~s/[\r\n\s]//g;
  }
  print "\n\nIf you need to access certain hosts and/or domains without the\n";
  print "Proxy Server, and/or your Proxy Server requires Proxy-Authentication,\n";
  print "you will need to configure the \"Proxyauth\" and \"Noproxy\" options\n";
  print "manually. Please see Section 6 of the LinkScan Reference Manual\n";
  print "Press 'return' to continue: ";
  $uHtT=<STDIN>;
}

print "\n\nNow LinkScan needs some information about the Website you want to scan.\n";
print "If LinkScan can access static HTML documents on this server via the local\n";
print "File System (or NFS) please enter the absolute file system pathname to the\n";
print "document root directory. Otherwise press return.\n";
print "For example: /usr/www/htdocs/\n";
print "Enter Home Directory: ";
$Cal='';
until($Cal){
  $Cal=<STDIN>;
  $Cal=~s/[\n\r\s]//g;
  unless($Cal){last;}
  unless($Cal=~m#/$#){$Cal .='/';}
  stat($Cal);
  if(! -d _){print "Invalid entry: $Cal\n";$Cal='';}
}

print "\n\nPlease enter the URL of the website you wish to scan.\n";
print "For example: http://www.example.com/\n";
$VvEy='';
until($VvEy=~m#^https?://#){
  print "Enter Home URL: ";
  $VvEy=<STDIN>;
  $VvEy=~s/[\n\r\s]//g;
}
$VvEy=~m#^(https?://[^/]+/?)(.*)$#i;
$VvEy=$1;
$qQg=$2;
unless($VvEy=~m#/$#){$VvEy .='/';}

$fik=1;
$gWu="me\100example.com";

open(SYS,">$QdB") or die "** Fatal Error: Could not write $QdB\n";
print "\nWriting configuration file $QdB ...\n";
print SYS <<END_CFG;

# LINKSCAN SYSTEM CONFIGURATION FILE - LINKSCAN.SYS
# !Version 12.4
#
# Lines beginning with "#" are comments
#
# Purpose:     The primary LinkScan system configuration file
# Location:    The LinkScan Directory only
# Required:    Always
# Applies to:  All configured Projects
# Inheritance: Not applicable
#
#==============================================================================
# ESSENTIAL PARAMETERS
#==============================================================================
#
# LicenseNumber  = 10-digit LinkScan License Number
# Licensee       = Company Name
# Key            = LinkScan License Key

LicenseNumber = $IoFU
Licensee = $UHv
Key = $aLkd

# Linkscandir    = Absolute File System Pathname to the LinkScan directory
# Perlpath       = Absolute File System Pathname the Perl 5 executable
# Weblintpath    = Absolute File System Pathname to the weblint executable
# Weblintoptions = Weblint command line options
# Cgibinurl      = Absolute URL to the LinkScan CGI's
# Docsurl        = Absolute URL to the LinkScan Documentation
# Reportsdir     = Absolute File System Pathname to the LinkScan Reports

Linkscandir = $KcsT
Perlpath = $wcFC
Weblintpath = $SNi
Weblintoptions = -d extension-markup,extension-attribute
Cgibinurl = $fkmu
Docsurl = $eYC
Reportsdir = $jnw

# Email related settings
# Sendmailpath     = Absolute File System Pathname to the sendmail executable
#                    Include the sendmail -t switch
# Smtphost         = SMTP hostname -- not used on UNIX systems
# Hostname         = Fully qualified hostname for this server (SMTP: HELO)
# Mailfrom         = From address (SMTP: MAIL FROM)
# Nameservers      = Domain Name Servers to use (comma separated list)

Sendmailpath = /usr/lib/sendmail -t
Smtphost =
Hostname = $met
Mailfrom =
Nameservers =

# Proxyserver      = The name of your HTTP Proxy Server (blank if none)
# Proxyport        = The port number of your HTTP Proxy Server
# Httpsproxyserver = The name of your HTTPS Proxy Server (blank if none)
# Httpsproxyport   = The port number of your HTTPS Proxy Server
# Noproxy          = Do not use Proxy for these servers (comma delimited list)
# Proxyauth        = "username:password" for Proxy Server authentication
# FTPUser          = Username to be used for anonymous FTP
# FTPPass          = Password to be used for anonymous FTP
# Linespeed        = Default line speed for slowest pages report
#                    1 = 28.8, 2 = 56K, 3 = ISDN, 4 = DSL, 5 = T-1

Proxyserver = $uxRV
Proxyport = $Tlw
Httpsproxyserver =
Httpsproxyport = 80
Noproxy =
Proxyauth =
FTPUser = anonymous
FTPPass = $gWu
Linespeed = 1

#==============================================================================
# OPTIONAL PARAMETERS
#==============================================================================
#
# LINK CHECKING PARAMETERS
#
# Masterhist     = Maintain site history data globally for all Projects
# Maxhist        = Max number of history entries to be stored
# Maxgoodhours   = Max number of hours between attempts to retest good ext links
# Maxbadhours    = Max number of hours between attempts to retest bad ext links
# Timeout1       = Timeout (in seconds) for first attempt to contact site
# Timeout2       = Timeout (in seconds) for second attempt to contact site
# Masterport     = Start of TCP/IP port number sequence used internally
# Slaves1        = Number of slaves for internal links
# Slaves2        = Number of slaves for external links
# Slavesfast1    = Number of slaves for internal links (with -fast option)
# Slavesfast2    = Number of slaves for external links (with -fast option)

Masterhist = 1
Maxhist = 10
Maxgoodhours = 4
Maxbadhours = 0
Timeout1 = 20
Timeout2 = 40
Masterport = 8010
Slaves1 = 3
Slaves2 = 6
Slavesfast1 = 5
Slavesfast2 = 12

# SERVER AND CGI ACCESS CONTROLS
#
# Linkscancookie = Type of cookie set by linkscan.cgi
#                  0=permanent; 1=session; 2=none
# Notapmapoptions= Disable the Options Menu on LinkScan/TapMap
# Noprojectlist  = Prompt for Project versus displaying drop-down list
# Nostaticmenu   = Disable the Menu Tools of command-line generated reports
# Httpauth       = Environment variable to check for HTTP user authentication
# Mailto         = Enable mailto option on LinkScan Reports (2=with comment box)

Linkscancookie = 0
Notapmapoptions = 0
Noprojectlist = 0
Nostaticmenu = 0
Httpauth = REMOTE_USER
Mailto = 1

# SERVER ACCESS CONTROLS (LinkScan WebServer only)
#
# Serverdeny     = IPaddress - deny access from IP address
# Serverallow    = IPaddress - allow access from IP address
# Serverauth     = username:password - use HTTP Basic Authentication
# Serverindex    = Allow server generated directory listings
#
# Serverdeny is processed before Serverallow. For example:
#   Serverdeny = .*
#   Serverallow = 10.10.10.10
#   Serverauth = myname:mypass
#   Serverindex = 0

Serverallow = .*
Serverindex = 1

# CGI ACCESS CONTROLS (Apply to any server)
#
# Access = username : password : project-list : owner-list : menu-options
#
# Use "*" for "any".
# project-list and owner-list are comma-delimited lists.
#
# Valid menu-options: xeskdbuvmycaohrpiqt
#
# x = Project Summary Report
# e = Problem Documents Report
# s = Document Detail Report
# k = Critical Errors Report
# d = Detailed Errors Report
# b = Changed Documents Report
# u = Search Documents Report
# v = Search Links Report
# m = SiteMap Report
# y = Summary of All Projects
# c = Selected Status Codes Report
# a = All Pages Linking To ... Report
# o = Orphaned Files Report
# h = External History Report
# r = Redirections Report
# p = System Configuration Report
# i = Document Weight Report
# q = LinkScan/QuickCheck
# t = LinkScan/TapMap
#
# The following default entry creates UNRESTRICTED ACCESS
#
# Access = * : * : * : * : *
#
# !1

Access = * : * : * : * : *

#==============================================================================
# PLEASE DO NOT CHANGE ITEMS BELOW THIS LINE
#==============================================================================

Helpcode8 = links07.html
Helpfile = linkscan.html
Mainmenu = linkscan.cgi
Mapcgi = linkmap.cgi
Statuscodefile = codes.txt
Templatefile = template.txt
Quickcgi = quick.cgi

QSource = 1
QLinkscan = 1
QWeblint = 0
QFormat = 1
QAdv = 0
QSev0 = 0
QSev1 = 1
QSev2 = 1
QSev3 = 1
QSev4 = 0
QSev5 = 0

#==============================================================================
# LinkScan
#==============================================================================
# (c) Copyright 1997-2013 Electronic Software Publishing Corporation (Elsop)
# All Rights Reserved.
# LinkScan(TM) and Elsop(TM) are Trademarks of
# Electronic Software Publishing Corporation.
# Email: linkscan\@elsop.com
# WWW: http://www.elsop.com/
#==============================================================================
# The end
#==============================================================================

END_CFG
close(SYS);

$OtT="user\@Mailhost";
open(SYS,">$pIe") or die "** Fatal Error: Could not write $pIe\n";
print "Writing configuration file $pIe ...\n";
print SYS <<END_CFG;

# LINKSCAN SITE CONFIGURATION FILE - LINKSCAN.CFG
# !Version 12.4
#
#==============================================================================
# THIS FILE BELONGS IN THE PROJECT DIRECTORY. EACH PROJECT INHERITS
# THE GLOBAL SETTINGS SPECIFIED IN THE LINKSCAN DIRECTORY. ANY OF
# THOSE SETTINGS MAY BE OVERRIDEN IN THIS PROJECT-SPECIFIC FILE.
#==============================================================================
#
# Lines beginning with "#" are comments
#
# Purpose:     The LinkScan Project configuration file
# Location:    The LinkScan directory and/or the Project Directory
# Required:    Yes
# Applies to:  The selected Project
# Inheritance: The LinkScan Directory is checked first. Those settings are
#              overriden or added to by the linkscan.cfg file in the selected
#              Project Directory
#
#==============================================================================
# ESSENTIAL PARAMETERS - MUST BE CONFIGURED
#==============================================================================
#
# Homedir       = Absolute pathname to the server root
# Homeurl       = Absolute URL to the server root
#                 Homedir and Homeurl *must* point at the *same* directory
# Mirrorurl     = Alternate URL to use for HTTP fetch requests
# Homefile      = Relative pathname to the starting page
# Mask          = Onlyinclude pathnames matching mask
# Projectdesc   = Project Description
# Organization  = Name of your organization for the reports
#
# Note: Specify subdirectories using Homefile rather than Homedir/Homeurl
# For example:
# Homedir = /usr/www/htdocs/
# Homeurl = http://localhost/
# Homefile = subdir/index.html

Homedir = $Cal
Homeurl = $VvEy
Mirrorurl =
Homefile = $qQg
Mask =
Projectdesc = $VJTv
Organization = $VJTv

# Http          = Use remote HTTP access to a non-local website
# Autohttp      = Automatically try HTTP access if File System access fails
# Casesensitive = Pathnames on the local server are case sensitive
# Maxcgi        = Max number of times any one script is probed with different
#                 query parameters
# Followext     = Follow redirections when scanning external links
# Retryext      = Retry external links at end of scan
# Showredirext  = Show external redirections
# Htmlfiles     = Files with these extensions are assumed to contain html
# Mapfiles      = Files with these extensions are assumed to contain imagemaps
# Pdffiles      = Files with these extensions are assumed to contain PDF docs
# Flashfiles    = Files with these extensions are assumed to contain Flash docs
# Textfiles     = Files with these extensions are assumed to contain plaintext
# Defaultpages  = LinkScan looks for these files in the order specified
# Indexoptions  = LinkScan will generate an index if no default page present
# Import        = Select Import mode; 1=links; 2=documents; 3=nocache
# Importfile    = Absolute pathname to import file
# Noorphan      = Disable Orphan checking
# Orphanfile    = Pathname to imported file system listing from lsfind
# Autoowner     = Automatic owner generation based on top-level dir

Http = 0
Autohttp = 0
Casesensitive = 1
Maxcgi = 100
Followext = 1
Retryext = 1
Showredirext = 0
Htmlfiles = html, shtml, htm
Mapfiles = map
Pdffiles =
Flashfiles = swf
Textfiles = txt
Defaultpages = index.html, index.shtml, index.htm, home.html, home.shtml, home.htm
Indexoptions = 0
Import = 0
Importfile =
Noorphan = 0
Orphanfile =
Autoowner = 1

#============================================================================
# OPTIONAL LINKSCAN CUSTOMIZATION COMMANDS
#==============================================================================



#==============================================================================
# SUMMARY OF LINKSCAN CUSTOMIZATION COMMANDS [aide memoire]
#==============================================================================
# SINGLE-VALUED COMMANDS [last occurrence counts]
#
# Checkmailto = boolean
# Closeatag = boolean
# Collectmeta = boolean
# Defaultowner = owner-name
# Editdoc = absolute-url-expression
# Editlink = absolute-url-expression
# Errorbody = expression
# Errordoc = relative-url-expression
# Expandssi = boolean
# Fetchext = boolean
# Followext = boolean
# Followframes = boolean
# Imgtags = [AHW]
# Maxclicks = integer
# Maxlevels = integer
# Noexternal = boolean
# Noforms = boolean
# Nohash = boolean
# Nomap = boolean
# Noorphan = boolean
# Nosplit = boolean
# Ownertags = expression
# Profiler = integer
# Profilerlog = boolean
# Profilermax = integer
# Sessionmatch = expression
# Showredirext = boolean
#
# USER-AGENT EXAMPLES
# Extraheader User-Agent: Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)
# Extraheader User-Agent: Mozilla/4.08 [en] (WinNT; I ;Nav)
#
# MULTI-VALUED COMMANDS [all occurrences count]
#
# Alias relative-path-expression absolute-path-expression
# Auth server-name "realm-name" username password
# Checkorphans relative-path-expression
# Cookie server-name cookie-name=cookie-value
# Exclude relative-path-expression
# Exclude absolute-url-expression
# Excludecookie expression
# Execute relative-path-expression
# Extraheader http-header-line
# Extrahome relative-path-expression
# Hostalias server-url
# Insertlink document-match new-document [-|+|*]
# Mailalias expression list-of-addresses
# Mimetypes mime-type [D|H|J|S|T]
# Nofollow relative-path-expression
# Noorphans relative-path-expression
# Onlyfollow relative-path-expression
# Onlyinclude relative-path-expression
# Onlyorphans relative-path-expression
# Owner relative-path-expression owner-name
# Owner *1
# Owneralias expression owner-name
# Redirect relative-path-expression absolute-url-expression
# Scriptexclude expression
# Scriptmatch expression
# Scriptnomatch expression
# Selecturl expression
# Sessionmatch expression
# Statuscode statuscode, severity
# Substitute relative-path-expression expression
# Substituteraw relative-path-expression expression
# Taglimit relative-path-expression maxnumber
# Tagonce relative-path-expression
# Userdata [123] match-expression expression
# Userdatafmt [123] [DHLTX] integer[LRC] caption
# Userdatasub [123] expression expression
#
# SITEMAP CUSTOMIZATION COMMANDS
#
# Mapdefaulttitle, [ string ] [ !PATH | !FILE ] [ string ]
# Mapext, boolean
# Mapinclude, relative-path-expression
# Maphide, relative-path-expression
# Mapmove, relative-document-path, new-parent-relative-path, position, new-title
# Maptitle, relative-document-path, new-title
#
#==============================================================================
# LinkScan
#==============================================================================
# (c) Copyright 1997-2013 Electronic Software Publishing Corporation (Elsop)
# All Rights Reserved.
# LinkScan(TM) and Elsop(TM) are Trademarks of
# Electronic Software Publishing Corporation.
# Email: linkscan\@elsop.com
# WWW: http://www.elsop.com/
#==============================================================================
# The end
#==============================================================================

END_CFG
close(SYS);

print "Updating shebang headers ...\n";
@psC=("linkscan.pl","linkscan2.pl","dispatch.pl","linkscan.cgi","linkmap.cgi","quick.cgi","linkdiag.pl","slave.pl","pinger.pl","utils/makeign.pl","utils/sendmail.pl","utils/tools.cgi");
foreach $GOcN(@psC){
  $rcU='';
  open(IN,"<$GOcN") || print "** Error: Opening $GOcN $!\n";
  open(OUT,">$GOcN.tmp") || print "** Error: Opening $GOcN.tmp $!\n";
  while(<IN>){
    $JpTn=$_;
    if(! $rcU && $JpTn =~ m/^#!/){
      $JpTn="#!$wcFC\n";
      $rcU=1;
    }
    print OUT $JpTn;
  }
  close(IN);
  close(OUT);
  unlink($GOcN) || print "** Error: Deleting $GOcN $!\n";
  rename("$GOcN.tmp", $GOcN) || print "** Error: Renaming $GOcN.tmp $!\n";
  chmod(0755,$GOcN);
}

if($EMn){
  print "Updating cgi scripts and copying them to $dxRF ...\n";
  @psC=('linkscan.cgi','linkmap.cgi','quick.cgi');
  foreach $GOcN(@psC){
    $rcU='';
    open(IN,"<$GOcN") || print "** Error: Opening $GOcN $!\n";
    open(OUT,">$dxRF$GOcN") || print "** Error: Opening $dxRF$GOcN $!\n";
    while(<IN>){
      $JpTn=$_;
      print OUT $JpTn;
    }
    close(IN);
    close(OUT);
    chmod(0755,$dxRF.$GOcN);
  }
  open(OUT,">$dxRF\.linkscan") || print "** Error: Opening $dxRF\.linkscan $!\n";
  print OUT "$KcsT\n";
  close(OUT);
  chmod(0644,"$dxRF\.linkscan");
}

$owH='';
open(IN,"<index.html");
while(<IN>){
  $owH .=$_;
}
close(IN);
$owH=~s/<a\s+href\s*=\s*".*?(linkscan\.cgi|quick\.cgi)"/<a href="$fkmu$1"/gis;
open(OUT,">index.html");
print OUT $owH;
close(OUT);

print "Completed.\n\n";
print "You may examine the following files using your favorite editor:\n";
print "  $QdB\n";
print "  $pIe\n\n";
print "Execute linkscan.pl to run LinkScan.\n\n";
exit;
## MTkxOTkzNg==

## End of file
