#!/usr/local/bin/perl
$version='12.4';
$file='linkdiag.txt';
print "Welcome to the LinkScan $version Diagnostics.\n";
print "This utility creates the ASCII file $file.\n";
print "Please mail this file to linkscan\@elsop.com on request.\n";
open(DIAG,">linkdiag.txt") or die "Could not open $file: $!\n";
$winnt=0;
if($^O=~m/mswin/i){$winnt=1;}
if($winnt){
  ($server)=gethostbyname('localhost');
  $login=getlogin();
}else{
  $server=`uname -n`;
  $login=getpwuid($>);
}
$server=~tr/\0\r\n//d;
print "Server Name: $server\n";
print "Login  Name: $login\n";
$perl=$];
$perl=~s/[\n\r]//g;
$eserver=$server;
$eserver=~s/(.)/uc sprintf("%%%02x",ord($1))/egs;
$elogin=$login;
$elogin=~s/(.)/uc sprintf("%%%02x",ord($1))/egs;
print DIAG "SYSTEM PARAMETERS per LinkDiag $version\n\n";
print DIAG "uname -a:    $server  $eserver\n";
print DIAG "Login:       $login  $elogin\n";
print DIAG "Perl:        $perl\n";
foreach $item(sort keys (%ENV)){
  print DIAG "ENV: $item = $ENV{$item}\n";
}

$lsdir='';
if($winnt){
  $lsdir=`cd`;
  $lsdir=~s/[\r\n\t]//g;
  $lsdir=~s#\\#/#g;
  $cmd='DIR';
}else{
  $lsdir=`pwd`;
  $lsdir=~s/[\r\n\t]//g;
  $cmd='ls -al';
}
unless($lsdir=~m#/$#){$lsdir .='/';}
print "Current Working Dir: $lsdir\n";
print DIAG "\n\nCurrent Working Dir: $lsdir\n\n";
open(INP,"$cmd |");
while(<INP>){
  s/[\r\n]//g;
  print DIAG "DIR $_\n";
}
close(INP);

$dotfile='.linkscan';
$sysfile='linkscan.sys';
$masfile='linkscan.mas';
$cfgfile='linkscan.cfg';
$audfile='linkscan.aud';
$dbgfile='linkscan.dbg';
$datadir='data/';

if(open(INP,"<$dotfile")){
  print "\n\nFILE: $dotfile\n\n";
  print DIAG "\n\nFILE: $dotfile\n\n";
  while(<INP>){
    s/[\r\n\s]//g;
    s/#.*//;
    unless($_){next;}
    $lsdir=$_;
  }
  close(INP);
  print "Followed .linkscan to: $lsdir\n";
  print DIAG "Followed .linkscan to: $lsdir\n";
}

print DIAG "\n\nFILE: $lsdir$sysfile\n\n";
open(INP,"<$lsdir$sysfile") or die "Could not open $lsdir$sysfile: $!\n";
while(<INP>){
  s/[\r\n]//g;
  if(m/^#/){next;}
  if($_){print DIAG "$_\n";}
  $var=$_;
  m/=(.*)/i;
  $val=$1;
  $var=~s/^\s+//;
  $var=~s/\s+$//;
  $val=~s/^\s+//;
  $val=~s/\s+$//;
  if($var=~m/^Linkscandir/i){$lsdir=$val;}
}
close(INP);
$audfile=$datadir.$audfile;

@files=($cfgfile);
foreach $file(@files){
  print DIAG "\n\nFILE: $lsdir$file \n\n";
  open(INP,"<$lsdir$file");
  while(<INP>){
    s/[\r\n]//g;
    if(m/^#/){next;}
    if($_){print DIAG "$_\n";}
  }
  close(INP);
}

print DIAG "\n\nFILE: $lsdir$masfile\n\n";
if(open(INP,"<$lsdir$masfile")){
  while(<INP>){
    s/[\r\n]//g;
    if(m/^#/){next;}
    if($_){
      print DIAG "$_\n";
      m/(\S+)/;
      push(@projects,$1);
    }
  }
  close(INP);
}

unless(@projects){@projects=('default');}
$line='=' x 72;
@files=($cfgfile,$audfile,$dbgfile);
foreach $proj(sort @projects) {
  print DIAG "\n$line\nPROJECT: $proj\n\n";
  foreach $file(@files){
    $afile=$proj.'/'.$file;
    print DIAG "\n\nFILE: $lsdir$afile \n\n";
    open(INP,"<$lsdir$afile");
    while(<INP>){
      s/[\r\n]//g;
      s/\cG/ \| /g;
      if(m/^#/){next;}
      if($_){print DIAG "$_\n";}
    }
    close(INP);
  }
}
close(DIAG);
print "Completed!\n";
exit;

