#!/usr/local/bin/perl
use Net::DNS;
#
# Net::DNS info: http://www.dimensional.com/~mfuhr/perldns/
#
#==============================================================================
# LinkScan
#==============================================================================
# (c) Copyright 1997-2010 Electronic Software Publishing Corporation (Elsop)
# All Rights Reserved.
# LinkScan(TM) and Elsop(TM) are
# Trademarks of Electronic Software Publishing Corporation
# WWW: http://www.elsop.com/  Email: linkscan@elsop.com
#
# See the file docs/license.txt for terms and conditions of use
#==============================================================================

$object = Net::DNS::Resolver->new();
open (SYS, "linkscan.sys") or die "Cannot open linkscan.sys";
while (<SYS>) {
  if (m/^\s*nameservers\s*=\s*(.*)/i) {
    @ns = split (/[,\s]+/, $1);
    $object->nameservers (@ns);
  }
}
close (SYS);
@ns = ();
@ns = $object->nameservers;
print "Using DNS Servers: @ns\n";
$host = 'aol.com';
@mx = mx ($object, $host);
if (@mx) {
  foreach $item (@mx) {
    $mxhost = $item->exchange;
    print "MXHost: $mxhost\n";
  }
} else {
  $error = $object->errorstring;
  print "Lookup error on $host: $error\n";
  if ($error =~ m/connect.*fail/i) {
    print "No good nameservers available\n";
    print "Add something like this to linkscan.sys:\n";
    print "Nameservers = xxx.xxx.xxx.xxx, yyy.yyy.yyy.yyy\n";
  }
}
exit;

